    '-------------------------------------------------------------------
    ' Locate in: ...\MediaMonkey\Scripts\Auto\Menu_SonosReplayGain.vbs
    '
    ' Version: 2.5
    ' Date: 21 Dec 2016
    ' By Rick Parsons (partly based on UndoAnalyzeVolume by DiddeLeeDoo)
    ' Tested on Windows XP, 7 & 10 using MediaMonkey 4.1.11 and Sonos 6.3.
    '
    ' The Set ... ReplayGain options require "Analyze Volume" to have been run first.
    '     Preferably with the option "Player / Volume Leveling / When analyzing
    '     Track volume, also analyze Album volume" set
    '     For Album Volume to be set the whole album must be Analyzed together
    '
    ' NOTE 1: **** This script uses Custom4 as a holding location. If this is
    '    used for anything else it will be corrupted. Change this to an
    '    unused custom field below.
    ' NOTE 2: **** An adjustment to the gain can be made to allow Sonos to
    '    use the headroom available.
    '
    ' Change log
    ' Note the version numbers for mp3rg2sc are separate and different
    '    v1.1 Added context (right click) menu option)
    '    v1.2 Allow for attenuated Track ReplayGain as well.
    '    v2.0 Call mp3rg2sc.exe for MP3 files to set the iTunNORM tag
    '    v2.1 Correct the in-progress message for Reset ReplayGain
    '    v2.2 mp3rg2sc ignores case of file extension
    '    v2.3 Improve the logic and error messages
    '    v2.5 Cosmetic changes
    '-------------------------------------------------------------------

Sub OnStartup
    Set UI = SDB.UI
    ' Add a section to the main tools menu
    Set Mnu = UI.AddMenuItemSub(UI.Menu_Tools, 4, 2)
        Mnu.Caption = SDB.Localize("Sonos ReplayGain")
        Mnu.IconIndex = 39
        ' Set Album ReplayGain
    Set Mn1 = UI.AddMenuItem(Mnu, 0, 0)
        Mn1.Caption = "Set Album ReplayGain"
        Mn1.UseScript = Script.ScriptPath
        Mn1.OnClickFunc = "Album"
        Mn1.IconIndex = 39
        ' Set Track ReplayGain
    Set Mn1 = UI.AddMenuItem(Mnu, 0, 0)
        Mn1.Caption = "Set Track ReplayGain"
        Mn1.UseScript = Script.ScriptPath
        Mn1.OnClickFunc = "Track"
        Mn1.IconIndex = 39
        ' Reset ReplayGain
    Set Mn2 = UI.AddMenuItem(Mnu, 0, 0)
        Mn2.Caption = "Reset ReplayGain"
        Mn2.UseScript = Script.ScriptPath
        Mn2.OnClickFunc = "Reset"
        Mn2.IconIndex = 39
        ' Clear ReplayGains
    Set Mn3 = UI.AddMenuItem(Mnu, 0, 0)
        Mn3.Caption = "Clear ReplayGains"
        Mn3.UseScript = Script.ScriptPath
        Mn3.OnClickFunc = "Clear"
        Mn3.IconIndex = 39
    ' Add a sectionto the Main window right click context menu
    Set Mnu = UI.AddMenuItemSub(UI.Menu_Pop_TrackList, 5, 6)
        Mnu.Caption = SDB.Localize("Sonos ReplayGain")
        Mnu.IconIndex = 39
        ' Set Album ReplayGain
    Set Mn1 = UI.AddMenuItem(Mnu, 0, 0)
        Mn1.Caption = "Set Album ReplayGain"
        Mn1.UseScript = Script.ScriptPath
        Mn1.OnClickFunc = "Album"
        Mn1.IconIndex = 39
        ' Set Track ReplayGain
    Set Mn1 = UI.AddMenuItem(Mnu, 0, 0)
        Mn1.Caption = "Set Track ReplayGain"
        Mn1.UseScript = Script.ScriptPath
        Mn1.OnClickFunc = "Track"
        Mn1.IconIndex = 39
        ' Reset ReplayGain
    Set Mn2 = UI.AddMenuItem(Mnu, 0, 0)
        Mn2.Caption = "Reset ReplayGain"
        Mn2.UseScript = Script.ScriptPath
        Mn2.OnClickFunc = "Reset"
        Mn2.IconIndex = 39
        ' Clear ReplayGains
    Set Mn3 = UI.AddMenuItem(Mnu, 0, 0)
        Mn3.Caption = "Clear ReplayGains"
        Mn3.UseScript = Script.ScriptPath
        Mn3.OnClickFunc = "Clear"
        Mn3.IconIndex = 39
    End Sub

Sub Album(o)
    If SDB.SelectedSongList.Count > 0 Then
        Set dbT = SDB.SelectedSongList
        Set Prg = SDB.Progress
        j = 0
        Prg.MaxValue = dbT.Count - 1
        Prg.Text = SDB.Localize("Seting Album ReplayGain...")
        For i = 0 To dbT.Count - 1
            Dim sw
            'Although, by the time mp3rg2sc is called, the wanted value is in Track Volume, we use
            '    this flag in case we get there before MediaMonkey has updated the tag.
            sw="/a"
            Set Sng = dbT.Item(i)
            If Sng.LevelingAlbum = -999999 Then
                ' Set warning flag
                j = 1
                ' Use Track Volume instead
                sw = ""
                ' It is safe to carry on as mp3rg2sc doesn't do anything if there is no value there
            End If
            ' See if we have already kept the Track Volume safe
' **** Use an available Custom field in the 2 lines below. The default is Custom4
            If Sng.Custom4 = "" And Sng.Leveling <> -999999 Then
                Sng.Custom4 = Sng.Leveling
            End If
            ' Now set the effective ReplayGain to be Album if available
            If Sng.LevelingAlbum = -999999 Then
' **** Use an available Custom field in the 2 lines below. The default is Custom4
                If Sng.Custom4 <> "" Then
                    Sng.Leveling = Sng.Custom4
                End If
            Else
                Sng.Leveling = Sng.LevelingAlbum
            End If
' **** Optional gain adjustment - change or uncomment to suit your requirements
'           If Sng.Leveling <> -999999 Then
'               Sng.Leveling = Sng.Leveling - 3.0
'           End If
            Sng.UpdateDB
            Sng.WriteTags
            Prg.Value = i
            Dim fso : Set fso = CreateObject("Scripting.FileSystemObject")
	    ' Ignore it if the program doesn't exist
            If fso.FileExists(SDB.ScriptsPath & "Auto\mp3rg2sc.exe") Then
                Dim wsh : Set wsh = CreateObject("WScript.Shell")
		' It doesn't do any harm to call it for all files
                Call wsh.Run("""" & SDB.ScriptsPath & "Auto\mp3rg2sc.exe"" " & sw & " """ & Sng.Path & """", 0, True)
            End If
            If Prg.Terminate Then Exit For
        Next
        Set Prg = Nothing
        Set dbT = Nothing
        If j = 1 Then
            SDB.MessageBox SDB.Localize("Album Volume is not available on one or more tracks, Track Volume is used"), mtError, Array(mbOk)
        End If
    Else
        SDB.MessageBox SDB.Localize("Please select the tracks to be processed"), mtError, Array(mbOk)
    End If
End Sub

Sub Track(o)
    If SDB.SelectedSongList.Count > 0 Then
        Set dbT = SDB.SelectedSongList
        Set Prg = SDB.Progress
        j = 0
        Prg.MaxValue = dbT.Count - 1
        Prg.Text=SDB.Localize("Setting Track ReplayGain...")
        For i = 0 To dbT.Count - 1
            Set Sng = dbT.Item(i)
            If Sng.Leveling = -999999 Then
                ' Set warning flag
                j = 1
                ' It is safe to carry on as mp3rg2sc doesn't do anything if there is no value there
            End If
            ' See if we have already kept the TrackGain safe
' **** Use an available Custom field in the 2 lines below. The default is Custom4
            If Sng.Custom4 = "" And Sng.Leveling <> -999999 Then
                Sng.Custom4 = Sng.Leveling
            End If
            ' Now set the effective ReplayGain to be Track
' **** Use an available Custom field in the 2 lines below. The default is Custom4
                If Sng.Custom4 <> "" Then
                    Sng.Leveling = Sng.Custom4
                End If
' **** Optional gain adjustment - change or uncomment to suit your requirements
'           If Sng.Leveling <> -999999 Then
'               Sng.Leveling = Sng.Leveling - 3.0
'           End If
            Sng.UpdateDB
            Sng.WriteTags
            Prg.Value = i
            Dim fso : Set fso = CreateObject("Scripting.FileSystemObject")
	    ' Ignore it if the program doesn't exist
            If fso.FileExists(SDB.ScriptsPath & "Auto\mp3rg2sc.exe") Then
                Dim wsh : Set wsh = CreateObject("WScript.Shell")
		' It doesn't do any harm to call it for all files
                Call wsh.Run("""" & SDB.ScriptsPath & "Auto\mp3rg2sc.exe"" """ & Sng.Path & """", 0, True)
            End If
            If Prg.Terminate Then Exit For
        Next
        Set Prg = Nothing
        Set dbT = Nothing
        If j = 1 Then
            SDB.MessageBox SDB.Localize("Track Volume is not available on one or more tracks. Please re-analyse these tracks"), mtError, Array(mbOk)
        End If
    Else
        SDB.MessageBox SDB.Localize("Please select the tracks to be processed"), mtError, Array(mbOk)
    End If
End Sub

Sub Reset(o)
    If SDB.SelectedSongList.Count > 0 Then
        Set dbT = SDB.SelectedSongList
        Set Prg = SDB.Progress
        Prg.MaxValue = dbT.Count - 1
        Prg.Text=SDB.Localize("Resetting ReplayGain...")
        For i = 0 To dbT.Count - 1
            Set Sng = dbT.Item(i)
            ' Only do it if there is a value to restore
' **** Use an available Custom field in the 3 lines below. The default is Custom4
            If Sng.Custom4 <> "" Then
                Sng.Leveling = Sng.Custom4
                Sng.Custom4 = ""
                Sng.UpdateDB
                Sng.WriteTags
            End If
            Prg.Value = i
            Dim fso : Set fso = CreateObject("Scripting.FileSystemObject")
	    ' Ignore it if the program doesn't exist
            If fso.FileExists(SDB.ScriptsPath & "Auto\mp3rg2sc.exe") Then
                Dim wsh : Set wsh = CreateObject("WScript.Shell")
	        ' It doesn't do any harm to call it for all files
                Call wsh.Run("""" & SDB.ScriptsPath & "Auto\mp3rg2sc.exe"" """ & Sng.Path & """", 0, True)
            End If
        If Prg.Terminate Then Exit For
        Next
        Set Prg = Nothing
        Set dbT = Nothing
    Else
        SDB.MessageBox SDB.Localize("Please select the tracks to be processed"), mtError, Array(mbOk)
    End If
End Sub


Sub Clear(o)
    If SDB.SelectedSongList.Count > 0 Then
        Set dbT = SDB.SelectedSongList
        Set Prg = SDB.Progress
        Prg.MaxValue = dbT.Count-1
        Prg.Text = SDB.Localize("Clearing ReplayGains...")
        For i = 0 To dbT.Count - 1
            Set Sng = dbT.Item(i)
            ' Just wipe it all out, no questions asked
            Sng.Leveling = -999999
            Sng.LevelingAlbum = -999999
' **** Use an available Custom field in the line below. The default is Custom4
            Sng.Custom4 = ""
            Sng.UpdateDB
            Sng.WriteTags
            Prg.Value = i
            Dim fso : Set fso = CreateObject("Scripting.FileSystemObject")
	    ' Ignore it if the program doesn't exist
            If fso.FileExists(SDB.ScriptsPath & "Auto\mp3rg2sc.exe") Then
                Dim wsh : Set wsh = CreateObject("WScript.Shell")
		' It doesn't do any harm to call it for all files
		' /r removes the iTunNORM tag. This guards against duplicates
                Call wsh.Run("""" & SDB.ScriptsPath & "Auto\mp3rg2sc.exe"" /r """ & Sng.Path & """", 0, True)
            End If
            If Prg.Terminate Then Exit For
            Next
        Set Prg = Nothing
        Set dbT = Nothing
    Else
        SDB.MessageBox SDB.Localize("Please select the tracks to be processed"), mtError, Array(mbOk)
    End If
End Sub
